# This file was auto-generated by Fern from our API Definition.

import typing

import httpx

from .core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .environment import StackOneEnvironment
from .resources.ats.client import AsyncAtsClient, AtsClient
from .resources.commons.client import AsyncCommonsClient, CommonsClient
from .resources.crm.client import AsyncCrmClient, CrmClient
from .resources.hris.client import AsyncHrisClient, HrisClient
from .resources.marketing.client import AsyncMarketingClient, MarketingClient


class StackOne:
    def __init__(
        self,
        *,
        base_url: typing.Optional[str] = None,
        environment: StackOneEnvironment = StackOneEnvironment.PRODUCTION,
        username: typing.Union[str, typing.Callable[[], str]],
        password: typing.Union[str, typing.Callable[[], str]],
        timeout: typing.Optional[float] = 60
    ):
        self._client_wrapper = SyncClientWrapper(
            base_url=_get_base_url(base_url=base_url, environment=environment),
            username=username,
            password=password,
            httpx_client=httpx.Client(timeout=timeout),
        )
        self.ats = AtsClient(client_wrapper=self._client_wrapper)
        self.commons = CommonsClient(client_wrapper=self._client_wrapper)
        self.crm = CrmClient(client_wrapper=self._client_wrapper)
        self.hris = HrisClient(client_wrapper=self._client_wrapper)
        self.marketing = MarketingClient(client_wrapper=self._client_wrapper)


class AsyncStackOne:
    def __init__(
        self,
        *,
        base_url: typing.Optional[str] = None,
        environment: StackOneEnvironment = StackOneEnvironment.PRODUCTION,
        username: typing.Union[str, typing.Callable[[], str]],
        password: typing.Union[str, typing.Callable[[], str]],
        timeout: typing.Optional[float] = 60
    ):
        self._client_wrapper = AsyncClientWrapper(
            base_url=_get_base_url(base_url=base_url, environment=environment),
            username=username,
            password=password,
            httpx_client=httpx.AsyncClient(timeout=timeout),
        )
        self.ats = AsyncAtsClient(client_wrapper=self._client_wrapper)
        self.commons = AsyncCommonsClient(client_wrapper=self._client_wrapper)
        self.crm = AsyncCrmClient(client_wrapper=self._client_wrapper)
        self.hris = AsyncHrisClient(client_wrapper=self._client_wrapper)
        self.marketing = AsyncMarketingClient(client_wrapper=self._client_wrapper)


def _get_base_url(*, base_url: typing.Optional[str] = None, environment: StackOneEnvironment) -> str:
    if base_url is not None:
        return base_url
    elif environment is not None:
        return environment.value
    else:
        raise Exception("Please pass in either base_url or environment to construct the client")
