# This file was auto-generated by Fern from our API Definition.

import typing

import httpx


class BaseClientWrapper:
    def __init__(
        self,
        *,
        username: typing.Union[str, typing.Callable[[], str]],
        password: typing.Union[str, typing.Callable[[], str]],
        base_url: str
    ):
        self._username = username
        self._password = password
        self._base_url = base_url

    def get_headers(self) -> typing.Dict[str, str]:
        headers: typing.Dict[str, str] = {
            "X-Fern-Language": "Python",
            "X-Fern-SDK-Name": "stackone",
            "X-Fern-SDK-Version": "0.0.16",
        }
        headers["Authorization"] = httpx.BasicAuth(self._get_username(), self._get_password())._auth_header
        return headers

    def _get_username(self) -> str:
        if isinstance(self._username, str):
            return self._username
        else:
            return self._username()

    def _get_password(self) -> str:
        if isinstance(self._password, str):
            return self._password
        else:
            return self._password()

    def get_base_url(self) -> str:
        return self._base_url


class SyncClientWrapper(BaseClientWrapper):
    def __init__(
        self,
        *,
        username: typing.Union[str, typing.Callable[[], str]],
        password: typing.Union[str, typing.Callable[[], str]],
        base_url: str,
        httpx_client: httpx.Client
    ):
        super().__init__(username=username, password=password, base_url=base_url)
        self.httpx_client = httpx_client


class AsyncClientWrapper(BaseClientWrapper):
    def __init__(
        self,
        *,
        username: typing.Union[str, typing.Callable[[], str]],
        password: typing.Union[str, typing.Callable[[], str]],
        base_url: str,
        httpx_client: httpx.AsyncClient
    ):
        super().__init__(username=username, password=password, base_url=base_url)
        self.httpx_client = httpx_client
