# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .resources.accounts.client import AccountsClient, AsyncAccountsClient
from .resources.applications.client import ApplicationsClient, AsyncApplicationsClient
from .resources.candidates.client import AsyncCandidatesClient, CandidatesClient
from .resources.connect_sessions.client import AsyncConnectSessionsClient, ConnectSessionsClient
from .resources.departments.client import AsyncDepartmentsClient, DepartmentsClient
from .resources.interview_stages.client import AsyncInterviewStagesClient, InterviewStagesClient
from .resources.interviews.client import AsyncInterviewsClient, InterviewsClient
from .resources.job_postings.client import AsyncJobPostingsClient, JobPostingsClient
from .resources.jobs.client import AsyncJobsClient, JobsClient
from .resources.locations.client import AsyncLocationsClient, LocationsClient
from .resources.rejected_reasons.client import AsyncRejectedReasonsClient, RejectedReasonsClient
from .resources.users.client import AsyncUsersClient, UsersClient


class AtsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._client_wrapper = client_wrapper
        self.connect_sessions = ConnectSessionsClient(client_wrapper=self._client_wrapper)
        self.accounts = AccountsClient(client_wrapper=self._client_wrapper)
        self.applications = ApplicationsClient(client_wrapper=self._client_wrapper)
        self.candidates = CandidatesClient(client_wrapper=self._client_wrapper)
        self.departments = DepartmentsClient(client_wrapper=self._client_wrapper)
        self.interview_stages = InterviewStagesClient(client_wrapper=self._client_wrapper)
        self.interviews = InterviewsClient(client_wrapper=self._client_wrapper)
        self.jobs = JobsClient(client_wrapper=self._client_wrapper)
        self.locations = LocationsClient(client_wrapper=self._client_wrapper)
        self.rejected_reasons = RejectedReasonsClient(client_wrapper=self._client_wrapper)
        self.users = UsersClient(client_wrapper=self._client_wrapper)
        self.job_postings = JobPostingsClient(client_wrapper=self._client_wrapper)


class AsyncAtsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._client_wrapper = client_wrapper
        self.connect_sessions = AsyncConnectSessionsClient(client_wrapper=self._client_wrapper)
        self.accounts = AsyncAccountsClient(client_wrapper=self._client_wrapper)
        self.applications = AsyncApplicationsClient(client_wrapper=self._client_wrapper)
        self.candidates = AsyncCandidatesClient(client_wrapper=self._client_wrapper)
        self.departments = AsyncDepartmentsClient(client_wrapper=self._client_wrapper)
        self.interview_stages = AsyncInterviewStagesClient(client_wrapper=self._client_wrapper)
        self.interviews = AsyncInterviewsClient(client_wrapper=self._client_wrapper)
        self.jobs = AsyncJobsClient(client_wrapper=self._client_wrapper)
        self.locations = AsyncLocationsClient(client_wrapper=self._client_wrapper)
        self.rejected_reasons = AsyncRejectedReasonsClient(client_wrapper=self._client_wrapper)
        self.users = AsyncUsersClient(client_wrapper=self._client_wrapper)
        self.job_postings = AsyncJobPostingsClient(client_wrapper=self._client_wrapper)
