# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ....core.datetime_utils import serialize_datetime
from .interview_stage import InterviewStage
from .interview_status_enum import InterviewStatusEnum
from .interviewer import Interviewer


class Interview(pydantic.BaseModel):
    id: str
    application_id: str
    interview_stage_id: str
    interview_stage: typing.Optional[typing.List[InterviewStage]]
    interview_status: InterviewStatusEnum
    interviewer_ids: typing.List[str]
    interviewers: typing.Optional[typing.List[Interviewer]]
    start_time: dt.datetime
    end_time: dt.datetime
    meeting_url: typing.Optional[str]
    created_at: typing.Optional[dt.datetime]
    updated_at: typing.Optional[dt.datetime]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
